from multiprocessing.pool import Pool
import time

def bincoeff(n, k):   #  Binomial coefficient
    if n==k or k==0:
        return 1
    else:
        return bincoeff(n-1, k-1) + bincoeff(n-1, k)


def Fib(n):    #   Fibonacci number
    if n==0 or n==1:
        return 1
    else:
        return Fib(n-1) + Fib(n-2)

def ck_func(param):
    """
          パラメータparamに対応して関数がプロセスとして実行される
    """
    if param[0] == 'B':
        v = bincoeff(param[1], param[2])
        return v, param[1], param[2]
    if param[0] == 'F':
        v = Fib(param[1])
        return v, param[1]
    else:
        return None

if __name__ == '__main__':
    n = 27
    k = 15
    v1 = time.perf_counter()  
    v = bincoeff(n, k)
    v2 = time.perf_counter() 
    print(f'v = {v},  n = {n},  k = {k}')
    print('time =', v2-v1)

    n = 36
    v1 = time.perf_counter() 
    v = Fib(n)
    v2 = time.perf_counter() 
    print(f'v = {v},  n = {n}')
    print('time =', v2-v1)

    params = [['B', 27, 15], ['F', 36]]   #   パラメータのリスト
    pool = Pool()        #   マルチプロセッシング用のプールの作成
    v1 = time.perf_counter()
    #
    #   パラメータのリストparamsの各要素に対して
    #   ck_funcがプロセスとして実行される
    #   返り値Resultsには、パラメータのリストparamsの各パラメータに
    #   対応して実行されたck_funcの返り値がリストの要素として返される
    #
    Results = pool.map(ck_func, params)
    v2 = time.perf_counter() 
    print('Results =\n', Results)
    print('time =', v2-v1)
        
        
