from multiprocessing.pool import Pool
import time

def bincoeff(n, k):
    if n==k or k==0:
        return 1
    else:
        return bincoeff(n-1, k-1) + bincoeff(n-1, k)

def bins(param):
    v = bincoeff(param[0], param[1])
    return v, param

if __name__ == '__main__':
    #
    #   ２項係数25_C_iを計算するためのパラメータリストの作成
    #
    params = []
    for i in range(26):
        params.append([25, i])
    #
    #     ２項係数を順番に計算してリストb_vsに格納
    #
    b_vs = []
    v1 = time.perf_counter()
    for p in params:
        v = bincoeff(p[0], p[1])
        b_vs.append([v, p])
    v2 = time.perf_counter()
    print('Values...\n', b_vs)
    print('time =', v2-v1)
        
    pool = Pool()            #   マルチプロセッシング用プールの作成
    v1 = time.perf_counter() 
    Results = pool.map(bins, params)   #   パラメータリストのパラメータに対応して
    v2 = time.perf_counter()           #   関数binsをプロセスとして実行
    print('Results...\n', Results)     #   Resultsには各プロセスの返り値が
    print('time =',v2-v1)              #   パラメータリストparamsの順序に対応して
                                       #   返される。
        
        
